function [particles] = boxPF_Initialise(initial)
%% Initialise the box particle filter

N = 16; % Number of box particles

velR = 10; xR = 50; abR = 30; % Amount of uncertainty for each state

if N==16
    lx = linspace(initial(1)-xR,initial(1)+xR,3);
    lxIn = infsup(lx(1:end-1),lx(2:end));
    lxv = linspace(initial(2)-velR,initial(2)+velR,2);
    lxvIn = infsup(lxv(1:end-1),lxv(2:end));
    ly = linspace(initial(3)-xR,initial(3)+xR,3);
    lyIn = infsup(ly(1:end-1),ly(2:end));
    lyv = linspace(initial(4)-velR,initial(4)+velR,2);
    lyvIn = infsup(lyv(1:end-1),lyv(2:end));
    lA = linspace(initial(5)-abR,initial(5)+abR,3);
    lAIn = infsup(lA(1:end-1),lA(2:end));
    lB = linspace(initial(6)-abR,initial(6)+abR,3);
    lBIn = infsup(lB(1:end-1),lB(2:end));
    s = 0;
    for i = 1:2
        for j = 1:2
            for m = 1:2
                for n = 1:2
                    s = s + 1;
                    particles.x(s,1) = lxIn(i);
                    particles.x(s,3) = lyIn(j);
                    particles.x(s,2) = lxvIn;
                    particles.x(s,4) = lyvIn;
                    particles.x(s,5) = lAIn(m);
                    particles.x(s,6) = lBIn(n);
                end
            end
        end
    end
elseif N == 4
    lx = linspace(initial(1)-xR,initial(1)+xR,2);
    lxIn = infsup(lx(1:end-1),lx(2:end));
    lxv = linspace(initial(2)-velR,initial(2)+velR,2);
    lxvIn = infsup(lxv(1:end-1),lxv(2:end));
    ly = linspace(initial(3)-xR,initial(3)+xR,2);
    lyIn = infsup(ly(1:end-1),ly(2:end));
    lyv = linspace(initial(4)-velR,initial(4)+velR,2);
    lyvIn = infsup(lyv(1:end-1),lyv(2:end));
    lA = linspace(initial(5)-abR,initial(5)+abR,3);
    lAIn = infsup(lA(1:end-1),lA(2:end));
    lB = linspace(initial(6)-abR,initial(6)+abR,3);
    lBIn = infsup(lB(1:end-1),lB(2:end));
    s = 0;
    for m = 1:2
        for n = 1:2
            s = s + 1;
            particles.x(s,1) = lxIn;
            particles.x(s,3) = lyIn;
            particles.x(s,2) = lxvIn;
            particles.x(s,4) = lyvIn;
            particles.x(s,5) = lAIn(m);
            particles.x(s,6) = lBIn(n);
        end
    end
else
    error('Currently working with either 4 or 16 box particles')
end

particles.indX = 1;
particles.indY = 3;
particles.indA = 5;
particles.indB = 6;
end
