function [state,measInt,FigParam,P] = crowdInitialise(P)

% Matched case state vector: [x,dx,y,dy,a,b]    
    P.num_P = poissrnd(P.num_person);
    meas{1}(:,1) = (P.init_state(1,5)*(rand(P.num_P,1)-0.5))+P.init_state(1,1); % initial measurements
    meas{1}(:,2) = (P.init_state(1,6)*(rand(P.num_P,1)-0.5))+P.init_state(1,3); % initial measurements
    state = P.init_state;
    % correlated velocity model
    num_it = ceil(P.t_max_s/P.dt_s);
    time_s = 0;t = P.dt_s;P.T = P.Tx;
    E = 2*t - 3*P.T;F = exp(-P.dt_s/P.T);
    A = [1,(1 - F)*P.T;0,F;];
    
    Q11 = [ ...
        P.T*E,     P.T; ...
        P.T  ,     1; ...
        ];
    
    Q12 = [ ...
        4*P.T^2,   -2*P.T; ...
        -2*P.T,       0; ...
        ];
    
    Q13 = [ ...
        -P.T^2,    P.T; ...
        P.T   ,   -1; ...
        ];
    
    Q1 = kron(eye(2),(Q11 + Q12*F + Q13*F^2)*P.rms_vel_mps^2);

        for n = 1:num_it-1
            time_s = time_s + P.dt_s;
            state(n+1,1:4) = mvnrnd(kron(eye(2),A)*state(n,1:4)',Q1);
            state(n+1,5:6) = mvnrnd(state(n,5:6),(P.dt_s)*eye(2)*P.Q2);
            P.num_P(n+1) = poissrnd(P.num_person);
            meas{n+1}(:,1) = (state(n+1,5)*(rand(P.num_P(n+1),1)-0.5))+state(n+1,1);
            meas{n+1}(:,2) = (state(n+1,6)*(rand(P.num_P(n+1),1)-0.5))+state(n+1,3);
        end
    for k = 1:P.timeSteps
        measInt{k} = meas{k} + repmat(P.measIntNoise',size(meas{k},1),1);
    end
    measInt = addClutter(measInt,state,P.measIntNoise,P.clutterRadius,P.clutterRo); 
    for k = 1:P.timeSteps
        if k == 1
            FigParam.x_min_fig_1 = min(measInt{k}.mid(:,1));
            FigParam.x_max_fig_1 = max(measInt{k}.mid(:,1));
            FigParam.y_min_fig_1 = min(measInt{k}.mid(:,2));
            FigParam.y_max_fig_1 = max(measInt{k}.mid(:,2));
        else
            if FigParam.x_min_fig_1 > min(measInt{k}.mid(:,1))
                FigParam.x_min_fig_1 = min(measInt{k}.mid(:,1));
            end
            if FigParam.x_max_fig_1 < max(measInt{k}.mid(:,1))
                FigParam.x_max_fig_1 = max(measInt{k}.mid(:,1));
            end
            if FigParam.y_min_fig_1 > min(measInt{k}.mid(:,2))
                FigParam.y_min_fig_1 = min(measInt{k}.mid(:,2));
            end
            if FigParam.y_max_fig_1 < max(measInt{k}.mid(:,2))
                FigParam.y_max_fig_1 = max(measInt{k}.mid(:,2));
            end
        end
    end
end
