function z = divideInt(y,x)
                % this function is a patch added to intlab for division operation.
                %in intlab, a division x/y and where y contains 0 can lead to NAN values
                % for instance
                %                 xx= infsup(0,2), yy= infsup(0,4), zz=xx/yy
                %                 intval xx =
                %                 [   0.00000000000000,   2.00000000000000]
                %                 intval yy =
                %                 [   0.00000000000000,   4.00000000000000]
                %                 intval zz =
                %                                 NaN
                
                % this is a correct spirit for intlab but this leads to incorrect values
                % for contraction algorithms.
                %
                % Added 3D division
                
                if length(size(x)) == 3
                    for i = 1:size(x,3)
                        z(:,:,i) = y(:,:,i)./x(:,:,i);
                    end
                else
                    z= y./x;
                end
                
                oneMat = ones(size(z));
                infinity=10^50;
                
                xInf = x.inf;
                xSup = x.sup;
                
                case0 = isnan(y.inf) | isnan(y.sup) |isnan(xInf) | isnan(xSup);
                case1 = xInf < 0 & xSup > 0;
                case2 = xInf == 0 & xSup ~= 0;
                case3 = xInf ~= 0 & xSup == 0;
                
                % check for case where x does not match y in size.
                if((size(x,1) == 1) && (size(x,2) == 1))
                   x = repmat(x,size(y,1),size(y,2));
                   case1 = repmat(case1,size(y,1),size(y,2)); 
                   case2 = repmat(case2,size(y,1),size(y,2)); 
                   case3 = repmat(case3,size(y,1),size(y,2)); 
                end
                
                z(case1)=infsup(-infinity, infinity);
                z(case2)=y(case2).*infsup(oneMat(case2)./sup(x(case2)), infinity*oneMat(case2));
                z(case3)=y(case3).*infsup(-infinity*oneMat(case3), inf(x(case3)));
                z(case0) = NaN;
            end
