function rectNew = evolutionModelCorrVel(rect,P)
% *************************************************************************
Tx = P.Tx;
Ty = P.Ty;

rectNew = rect;
xx = rect.x;
N = size(xx,1);

% Noise components for x-coordinate
Ex = 2*P.dt_s - 3*Tx;
Fx = exp(-P.dt_s/Tx);

Ax = [1, (1 - Fx)*Tx;
    0,         Fx];

Q0x = [Tx*Ex,  Tx;
    Tx,    1];

Q1x = [4*Tx^2,  -2*Tx;
    -2*Tx,     0];

Q2x = [-Tx^2,   Tx;
    Tx,    -1];

Qx = (Q0x + Q1x*Fx + Q2x*Fx^2)*(3*P.rms_vel_mps)^2;

% Noise components for y-coordinate
Ey = 2*P.dt_s - 3*Ty;
Fy = exp(-P.dt_s/Ty);

Ay = [1, (1 - Fy)*Ty;
    0,         Fy];

Q0y = [Ty*Ey,  Ty;
    Ty,    1];

Q1y = [4*Ty^2,  -2*Ty;
    -2*Ty,     0];

Q2y = [-Ty^2,   Ty;
    Ty,    -1];

Qy = (Q0y + Q1y*Fy + Q2y*Fy^2)*(3*P.rms_vel_mps)^2;

[vecX, valX] = eig(Qx);
[vecY, valY] = eig(Qy);

u1x = sqrt(valX(1, 1))*vecX(:, 1);
u2x = sqrt(valX(2, 2))*vecX(:, 2);

u1y = sqrt(valY(1, 1))*vecY(:, 1);
u2y = sqrt(valY(2, 2))*vecY(:, 2);

xNew(:, 1:2) = xx(:, 1:2)*Ax' + repmat(u1x',N,1).*3*infsup(-1,1) + repmat(u2x',N,1).*3*infsup(-1,1);
xNew(:, 3:4) = xx(:, 3:4)*Ay' + repmat(u1y',N,1).*3*infsup(-1,1) + repmat(u2y',N,1).*3*infsup(-1,1);
W2 = 3*infsup(-1,1)*sqrt(P.dt_s)*repmat([sqrt(P.Q2),sqrt(P.Q2)],N,1);
xNew(:,5:6) = xx(:,5:6) + W2;

rectNew.x = xNew;
end