function [xNew,choice,numPerParticle] = resampling(rect)
bootstrap = 1;
if bootstrap
    N = size(rect.x,1);
    xNew = rect;
    
    % Select from which particles to resample
    cumSum = cumsum(rect.weights);
    choice = sort(sum(repmat(rand(1,N),N,1) > repmat(cumSum, 1, N))+1)';
    xNew.x = rect.x(choice,:);
    
    uniqueParticles = unique(choice);
    uniqueMat = repmat(uniqueParticles', N, 1);
    lengthUniqueParticles = length(uniqueParticles);
    choiceMat = repmat(choice, 1, lengthUniqueParticles);
    numPerParticle = (sum(uniqueMat == choiceMat));
    whichSection = repmat(infsup(0,1),N,6);
    for m = 1:length(uniqueParticles)
        u = 2;
        d = floor(log2(numPerParticle(m)));
        if d > 0
            if d > 4
                d = 4;
            end
            c = infsup((0:u-1)/u,(1:u)/u)';
            cc = c(fullfact(u*ones(1,d)));
        end
        if d == 0
            
        elseif d == 4
            whichSection(sum(numPerParticle(1:m-1))+1:sum(numPerParticle(1:m-1))+size(cc,1),1) = cc(:,1);
            whichSection(sum(numPerParticle(1:m-1))+1:sum(numPerParticle(1:m-1))+size(cc,1),3) = cc(:,2);
            whichSection(sum(numPerParticle(1:m-1))+1:sum(numPerParticle(1:m-1))+size(cc,1),5) = cc(:,3);
            whichSection(sum(numPerParticle(1:m-1))+1:sum(numPerParticle(1:m-1))+size(cc,1),6) = cc(:,4);
            v = numPerParticle(m) - 2^d;
            if v > 0
                vInd = 7;
                while((vInd > 6) || (vInd == 2) || (vInd == 4))
                    vInd = randi(6);
                end
                whichSection(sum(numPerParticle(1:m-1))+size(cc,1)+1:sum(numPerParticle(1:m)),vInd)= infsup((0:v-1)/v,(1:v)/v)';
            end
        else
            v = rect.x(uniqueParticles(m),:).rad;
            [~,vInd] = sort(v);
            vInd((vInd == 2) | (vInd == 4)) = [];
            whichSection(sum(numPerParticle(1:m-1))+1:sum(numPerParticle(1:m-1))+size(cc,1),vInd(end-d+1:end)) = cc;
            vInd(end-d+1:end) = [];
            v = numPerParticle(m) - 2^d;
            if v > 0
                whichSection(sum(numPerParticle(1:m-1))+size(cc,1)+1:sum(numPerParticle(1:m)),vInd(end))= infsup((0:v-1)/v,(1:v)/v)';
            end
        end
    end
    
    % Obtain the new samples & equalise the weights
    xNew.x = xNew.x.inf + whichSection.*xNew.x.rad*2;
    xNew.weights = ones(N,1)/N;
else
    xNew = rect;
end

end