function [perf,xNew,P] = update(rect, meas, rectPr, perf,k, P, state, PrevAreaEst)

xNew = rect;
contIterations = 1;
N = size(rect.x,1);
M = size(meas,1);

for it = 1:contIterations
    [xyCont0, abCont0, mxyCont1, xvyvCont0] = contraction(xNew, meas, contIterations, rectPr, P);
end
% this eliminates clutter points from outside of the boxes
% from contraction.
if ~isempty(xvyvCont0)
    nanvec = isnan(xyCont0(1:N,:)) | isnan(xyCont0(N+1:end,:))...
        | isnan(abCont0(1:N,:)) | isnan(abCont0(N+1:end,:)) ...
        | isnan(xvyvCont0(1:N,:)) | isnan(xvyvCont0(N+1:end,:));
    
    xyCont0([nanvec;nanvec]) = NaN;
    abCont0([nanvec;nanvec]) = NaN;
    xvyvCont0([nanvec;nanvec]) = NaN;
    
    ContrMeasInd = ((~isnan(xyCont0(1:N,:)))...
        & (~isnan(xyCont0(N+1:end,:)))...
        & (~isnan(abCont0(1:N,:)))...
        & (~isnan(abCont0(N+1:end,:))))...
        & ((xyCont0(1:N,:).rad < repmat(rect.x(:,1).rad,1,M))...
        | (xyCont0(N+1:end,:).rad < repmat(rect.x(:,3).rad,1,M))...
        | (abCont0(1:N,:).rad < repmat(rect.x(:,5).rad,1,M))...
        | (abCont0(N+1:end,:).rad < repmat(rect.x(:,6).rad,1,M)));
    
    totcmv = sum(((~isnan(xyCont0(1:N,:)))...
        & (~isnan(xyCont0(N+1:end,:)))...
        & (~isnan(abCont0(1:N,:)))...
        & (~isnan(abCont0(N+1:end,:)))),2);
    eta = 1.1;
    perf.C(k) = (perf.C(k-1)/eta) + max(totcmv);
    perf.D(k) = (perf.D(k-1)/eta) + 1;
    
    perf.C2(k) = (perf.C2(k-1)/eta) + max(M-totcmv);
    perf.D2(k) = (perf.D2(k-1)/eta) + 1;
    estmeasLambda = perf.C(k) / perf.D(k);
    estClutterLambda = perf.C2(k) / perf.D2(k);
    estclutterArea = pi*P.clutterRadius^2 - (PrevAreaEst(1).mid*PrevAreaEst(2).mid);
    estclutterRo = estClutterLambda / estclutterArea;
    estXY = repmat(infsup(0,0),2*N,1);
    estXYv = repmat(infsup(0,0),2*N,1);
    estAB = repmat(infsup(0,0),2*N,1);
    
    maxclp = round(((((rect.x(:,1).sup+(rect.x(:,5).sup)/2) - (rect.x(:,1).inf-(rect.x(:,5).sup)/2))...
        .*((rect.x(:,3).sup+(rect.x(:,6).sup)/2) - (rect.x(:,3).inf-(rect.x(:,6).sup)/2)))...
        -(((rect.x(:,1).inf+(rect.x(:,5).inf)/2) - (rect.x(:,1).sup-(rect.x(:,5).inf)/2))...
        .*((rect.x(:,3).inf+(rect.x(:,6).inf)/2) - (rect.x(:,3).sup-(rect.x(:,6).inf)/2))))'*estclutterRo/4);
    for m = 1:N
        
        if (sum(ContrMeasInd(m,:))==0)
            estXY(m) = rect.x(m,1);
            estXY(m+N) = rect.x(m,3);
            estXYv(m) = rect.x(m,2);
            estXYv(m+N) = rect.x(m,4);
            estAB(m) = rect.x(m,5);
            estAB(m+N) = rect.x(m,6);
        else
            estXY(m) = intersectR(xyCont0(m,ContrMeasInd(m,:)),maxclp(m));
            estXY(m+N) = intersectR(xyCont0(m+N,ContrMeasInd(m,:)),maxclp(m));
            estXYv(m) = intersectR(xvyvCont0(m,ContrMeasInd(m,:)),maxclp(m));
            estXYv(m+N) = intersectR(xvyvCont0(m+N,ContrMeasInd(m,:)),maxclp(m));
            estAB(m) = intersectR(abCont0(m,ContrMeasInd(m,:)),maxclp(m));
            estAB(m+N) = intersectR(abCont0(m+N,ContrMeasInd(m,:)),maxclp(m));
        end
    end
    xNew.x = [    estXY(1:N) estXYv(1:N)...
        estXY(N+1:2*N) estXYv(N+1:2*N)...
        estAB(1:N) ...
        estAB(N+1:2*N)];
    
else
    nanvec = isnan(xyCont0(1:N,:)) | isnan(xyCont0(N+1:end,:))...
        | isnan(abCont0(1:N,:)) | isnan(abCont0(N+1:end,:));
    
    xyCont0([nanvec;nanvec]) = NaN;
    abCont0([nanvec;nanvec]) = NaN;
    
    ContrMeasInd = ((~isnan(xyCont0(1:N,:)))...
        & (~isnan(xyCont0(N+1:end,:)))...
        & (~isnan(abCont0(1:N,:)))...
        & (~isnan(abCont0(N+1:end,:))))...
        & ((xyCont0(1:N,:).rad < repmat(rect.x(:,1).rad,1,M))...
        | (xyCont0(N+1:end,:).rad < repmat(rect.x(:,3).rad,1,M))...
        | (abCont0(1:N,:).rad < repmat(rect.x(:,5).rad,1,M))...
        | (abCont0(N+1:end,:).rad < repmat(rect.x(:,6).rad,1,M)));
    
    totcmv = sum(((~isnan(xyCont0(1:N,:)))...
        & (~isnan(xyCont0(N+1:end,:)))...
        & (~isnan(abCont0(1:N,:)))...
        & (~isnan(abCont0(N+1:end,:)))),2);
    
    perf.C(k) = max(totcmv);
    perf.D(k) = 1;
    
    perf.C2(k) = max(M-totcmv);
    perf.D2(k) = 1;
    
    estmeasLambda = perf.C(k) / perf.D(k);
    estclutterLambda = perf.C2(k) / perf.D2(k);
    estclutterArea = pi*P.clutterRadius^2;
    estclutterRo = estclutterLambda / estclutterArea;
    
    estXY = repmat(infsup(0,0),2*N,1);
    estAB = repmat(infsup(0,0),2*N,1);
    
    maxclp = round(((((rect.x(:,1).sup+(rect.x(:,5).sup)/2) - (rect.x(:,1).inf-(rect.x(:,5).sup)/2))...
        .*((rect.x(:,3).sup+(rect.x(:,6).sup)/2) - (rect.x(:,3).inf-(rect.x(:,6).sup)/2)))...
        -(((rect.x(:,1).inf+(rect.x(:,5).inf)/2) - (rect.x(:,1).sup-(rect.x(:,5).inf)/2))...
        .*((rect.x(:,3).inf+(rect.x(:,6).inf)/2) - (rect.x(:,3).sup-(rect.x(:,6).inf)/2))))'*estclutterRo/4);
    for m = 1:N
        estXY(m) = intersectR(xyCont0(m,ContrMeasInd(m,:)),maxclp(m));
        estXY(m+N) = intersectR(xyCont0(m+N,ContrMeasInd(m,:)),maxclp(m));
        estAB(m) = intersectR(abCont0(m,ContrMeasInd(m,:)),maxclp(m));
        estAB(m+N) = intersectR(abCont0(m+N,ContrMeasInd(m,:)),maxclp(m));
    end
    xNew.x = [    estXY(1:N) rect.x(:,2)...
        estXY(N+1:2*N) rect.x(:,4)...
        estAB(1:N) ...
        estAB(N+1:2*N)];
end

xInit = prod(rect.x.rad,2);
xCont = prod(xNew.x.rad,2);

L = ((totcmv-maxclp').*log((1./(xNew.x(:,5).mid.*xNew.x(:,6).mid.*xInit))...
    *(estmeasLambda/estclutterRo)))+((M-(totcmv-maxclp')).*log(1./xInit))+log(xCont);

L(isnan(L)) = 10^-100;
L(L == 0) = 10^-100;
if k == 1
    w = exp(L - max(L)); 
else
    w = rect.weights.*exp(L - max(L)); 
end
w(isnan(w)) = 0;
xNew.weights = w/sum(w);
perf.ESS(k) = 1/sum(xNew.weights.^2);

% Plotting for video
plotIntShape;
end