function[xParticle_pred, c]= PF_prediction(xParticle_pf)
%
%  PREDICTION STEP
%
global dt_s N nx R_sqrt Q2 rms_vel_mps T
%
% correlated velocity model
E = 2*dt_s - 3*T;F = exp(-dt_s/T);
A = [1,(1 - F)*T;0,F;];

Q11 = [ ...
    T*E,     T; ...
    T  ,     1;];

Q12 = [ ...
    4*T^2,   -2*T; ...
    -2*T,       0;];

Q13 = [ ...
    -T^2,    T; ...
    T   ,   -1;];

Q1 = kron(eye(2),(Q11 + Q12*F + Q13*F^2)*rms_vel_mps^2);

xParticle_pred = zeros(nx,N);

yParticle_pred = zeros(N,2,2);
for i = 1:N
    predict = mvnrnd(kron(eye(2),A)*xParticle_pf(1:4,i),Q1);
    predict(5:6) = mvnrnd(xParticle_pf(5:6,i),(dt_s)*eye(2)*Q2);
    xParticle_pred(:,i)= predict;
    
    xParticle_pred_cnr(i,1,1)=  predict(1) + predict(5)/2;
    xParticle_pred_cnr(i,2,1)=  predict(3) + predict(6)/2;
    xParticle_pred_cnr(i,1,2)=  predict(1) - predict(5)/2;
    xParticle_pred_cnr(i,2,2)=  predict(3) - predict(6)/2;
end
yParticle_pred(:,1,1)=  xParticle_pred_cnr(:,1,1) + 3*R_sqrt(1);
yParticle_pred(:,2,1)=  xParticle_pred_cnr(:,2,1) + 3*R_sqrt(4);
yParticle_pred(:,1,2)=  xParticle_pred_cnr(:,1,2) - 3*R_sqrt(1);
yParticle_pred(:,2,2)=  xParticle_pred_cnr(:,2,2) - 3*R_sqrt(4);

c.yP = yParticle_pred;
c.xP = xParticle_pred_cnr;
return;
