global rms_vel_mps T Q2
num_person = 100; % poisson mean number of people in the crowd
% state vector: [x,dx,y,dy,a,b]
% [x,y] represent the center of a rectangle.
% [dx,dy] represent the velocity of the centre of a rectangle
% [a,b] represent the length of the sides (horizontal and vertical) of a rectangle
% measurements are uniformly located on the rectangle. 

num_P = poissrnd(num_person);
mvv.meas(:,1) = (state(1,5)*(rand(num_P,1)-0.5))+state(1,1); % initial measurements
mvv.meas(:,2) = (state(1,6)*(rand(num_P,1)-0.5))+state(1,3); % initial measurements

% correlated velocity model
rms_vel_mps = 10; % RMS velocity
T = 15; % velocity correlation time
Q2 = 1; % variance of random walk for the sides
num_it = ceil(t_max_s/dt_s);
time_s = 0;t = dt_s;
E = 2*t - 3*T;F = exp(-dt_s/T);
A = [1,(1 - F)*T;0,F;];

Q11 = [ ...
    T*E,     T; ...
    T  ,     1;];

Q12 = [ ...
    4*T^2,   -2*T; ...
    -2*T,       0;];

Q13 = [ ...
    -T^2,    T; ...
    T   ,   -1;];

Q1 = kron(eye(2),(Q11 + Q12*F + Q13*F^2)*rms_vel_mps^2);
    for n = 1:num_it-1
        time_s = time_s + dt_s;
        state(n+1,1:4) = mvnrnd(kron(eye(2),A)*state(n,1:4)',Q1);
        state(n+1,5:6) = mvnrnd(state(n,5:6),(dt_s)*eye(2)*Q2);
        num_P(n+1) = poissrnd(num_person);
        mvv(n+1).meas(:,1) = (state(n+1,5)*(rand(num_P(n+1),1)-0.5))+state(n+1,1);
        mvv(n+1).meas(:,2) = (state(n+1,6)*(rand(num_P(n+1),1)-0.5))+state(n+1,3);
    end
x_min_fig_1 = min(state(:,1)-max(state(:,5)/2))-max(state(:,5)/2);
x_max_fig_1 = max(state(:,1)+max(state(:,5)/2))+max(state(:,5)/2);
y_min_fig_1 = min(state(:,3)-max(state(:,6)/2))-max(state(:,6)/2);
y_max_fig_1 = max(state(:,3)+max(state(:,6)/2))+max(state(:,6)/2);

        measSigma = 0.1;
        for n = 1:num_it
            measurements(n).m = mvv(n).meas + measSigma.*randn(length(mvv(n).meas),2);
        end

if clut
    measurements = addClutter(measurements,state);
end