function rectNew = evolutionModelCorrVel(rect,P)
% *************************************************************************
Tx = P.Tx;
Ty = P.Ty;

rectNew = rect;
xx = rect.x;

% Noise components for x-coordinate
Ex = 2*P.dt_s - 3*Tx;
Fx = exp(-P.dt_s/Tx);

Ax = [1, (1 - Fx)*Tx;
    0,         Fx];

Q0x = [Tx*Ex,  Tx;
    Tx,    1];

Q1x = [4*Tx^2,  -2*Tx;
    -2*Tx,     0];

Q2x = [-Tx^2,   Tx;
    Tx,    -1];

Qx = (Q0x + Q1x*Fx + Q2x*Fx^2)*(3*P.rms_vel_mps)^2;

% Noise components for y-coordinate
Ey = 2*P.dt_s - 3*Ty;
Fy = exp(-P.dt_s/Ty);

Ay = [1, (1 - Fy)*Ty;
    0,         Fy];

Q0y = [Ty*Ey,  Ty;
    Ty,    1];

Q1y = [4*Ty^2,  -2*Ty;
    -2*Ty,     0];

Q2y = [-Ty^2,   Ty;
    Ty,    -1];

Qy = (Q0y + Q1y*Fy + Q2y*Fy^2)*(3*P.rms_vel_mps)^2;

xNew(:,1:4) = mvnrnd(xx(:,1:4)*kron(eye(2),Ax)',kron(eye(2),Qx));
xNew(:,5:6) = mvnrnd(xx(:,5:6),(P.dt_s)*eye(2)*P.Q2);

rectNew.x = xNew;
end