clear;close all hidden;clc;
systemInitialise
[state,meas,figParam,Param] = crowdInitialise(Param);  
[particles] = PF_Initialise(state(1,:));
for k = 1:Param.timeSteps
    if k > 1
        %% Prediction
        particlesPred = evolutionModelCorrVel(particles,Param);
    end
    %% Update
    if k == 1
        [perf,particlesUpdate] = update(particles,meas{k},perf,k,Param);
    else
        [perf,particlesUpdate] = update(particlesPred,meas{k},perf,k,Param);
    end
    %% Estimate
    estimate(k,:) = particlesUpdate.weights'*particlesUpdate.x;
    %% Resampling
    [particles] = resampling(particlesUpdate);
    %% Visualisation
         visualise;
    fprintf('timestep = %i / %i.\r',k,Param.timeSteps);
end    
set(0, 'DefaultFigureVisible', 'on')
if Param.saveMovie
    close(writerObj);
end