perf.r = 1;
perf.numRuns = 1;
perf.start = 1;

% Control level of visualisation:
% 0 - No visuals during simulations, should be set to 0 for Monte Carlo runs.
% 1 - plot the results

perf.visual = 0;

if perf.visual == 0
    set(0, 'DefaultFigureVisible', 'off')
else
    set(0, 'DefaultFigureVisible', 'on')
end

Param.saveMovie = 1;
if Param.saveMovie
    try
        writerObj = VideoWriter('example.mp4','MPEG-4');
        writerObj.FrameRate = 32;
        open(writerObj);
    catch
        close(writerObj);
        writerObj = VideoWriter('example.mp4','MPEG-4');
        writerObj.FrameRate = 32;
        open(writerObj);
    end
end

%Simulation & model parameters

Param.num_person = 100; % number of people in the crowd
Param.dt_s = 0.125; % sampling time
    Param.init_state = [100,0,100,0,40,40]; % initial state [x,dx,y,dy,A,B]
    Param.t_max_s = 40; % Simulation time
    Param.rms_vel_mps = 10; % RMS velocity 
    Param.Tx = 15; % velocity correlation time x
Param.Ty = 15; % velocity correlation time y
Param.Q2 = 1; % variance of random walk for the sides
Param.timeSteps = Param.t_max_s/Param.dt_s; % number of time steps
Param.measSigma = [0.1; 0.1]; % Measurement noise in Cartesian coordinates

Param.clutterRo = 1e-2;
Param.clutterRadius = 100; % meters
Param.measLambda = 100;
Param.fig = figure('color',[1 1 1]);

clear('v','cont')